local function radioDef_init();

  while (model.getMixesCount(24) > 0) do model.deleteMix(24, 0) end;
  mixerData = {name="Tr-ail", source=159, weight=102, offset=1, multiplex=0
    , curveType=0, curveValue=0, flightModes=512, carryTrim=0, mixWarn=0, delayUp=0, delayDown=0, speedUp=0, speedDown=0};
  model.insertMix(24, 0, mixerData);

  while (model.getMixesCount(25) > 0) do model.deleteMix(25, 0) end;
  mixerData = {name="Tr-ele", source=160, weight=102, offset=2, multiplex=0
    , curveType=0, curveValue=0, flightModes=512, carryTrim=0, mixWarn=0, delayUp=0, delayDown=0, speedUp=0, speedDown=0};
  model.insertMix(25, 0, mixerData);

  while (model.getMixesCount(26) > 0) do model.deleteMix(26, 0) end;
  mixerData = {name="Tr-thr", source=162, weight=118, offset=-13, multiplex=0
    , curveType=0, curveValue=0, flightModes=512, carryTrim=0, mixWarn=0, delayUp=0, delayDown=0, speedUp=0, speedDown=0};
  model.insertMix(26, 0, mixerData);

  while (model.getMixesCount(27) > 0) do model.deleteMix(27, 0) end;
  mixerData = {name="Tr-rud", source=161, weight=108, offset=1, multiplex=0
    , curveType=0, curveValue=0, flightModes=512, carryTrim=0, mixWarn=0, delayUp=0, delayDown=0, speedUp=0, speedDown=0};
  model.insertMix(27, 0, mixerData);

  return
  end

local function radioDef_run(event)
  lcd.clear();
  if lineSizeMID == nil then lineSizeMID = 17; lineSizeSML = 9; end
  lcd.drawText (0, 0,"Student Mixers", MIDSIZE);
  lcd.drawText (0, lineSizeMID,"settings recalled", MIDSIZE);
  lcd.drawText (0, 2*lineSizeMID,"from script ", MIDSIZE);
  lcd.drawText (0, 3*lineSizeMID,"/stuRadio/CockMM", MIDSIZE);
  return 0;
end

return { init=radioDef_init, run=radioDef_run };

