-- entspricht test14.lua = funktionsfähig
-- local for all functions in script

  local searchedSwitchIndex;
  local existingGvar9Value;
  local logSwitchId;
  local specFuncIdOne;
  local specFuncIdTwo;
  local valueOne = 0;
  local valueTwo = 0;
  local loopNr = 100;
  local loopNrMin = 20;
  local step = 0;

--########## find undefind log-switch and customfunction  #############################

local function findLogSwitchOne_start()
  local ii;

     ii = 0;
     while ii >=0 and ii <= 63 do
         result = model.getLogicalSwitch(ii)
         if result.func == 0 then 
	     logSwitchId = ii;
             ii = -1
           else;
             ii = ii + 1;
           end;  
       end;

     result = nil;

     ii = 0;
     while ii >=0 and ii <= 63 do
         result = model.getCustomFunction(ii)
         if result.switch == 0 then 
	     specFuncIdOne = ii;
             kk = ii + 1;
             ii = -1
           else;
             ii = ii + 1;
           end;  
       end;

     ii = kk;
     while ii >=kk and ii <= 63 do
         result = model.getCustomFunction(ii)
         if result.switch == 0 then 
	     specFuncIdTwo = ii;
             ii = -1
           else;
             ii = ii + 1;
           end;  
       end;

     if (logSwitchId == nil) or (specFuncIdOne == nil) or (specFuncIdTwo == nil) then
         step = 11;
       else
         step = 1;
       end

--### adjust log switch numbers
     loopNr = loopNr + logSwitchId;
     loopNrMin = loopNrMin + logSwitchId;

return
end



--######## write lua script ###############
local function findLogSwitchOne_file(inSwitch)
    local my_file = io.open ("/SCRIPTS/TOOLS/trainer/numL01.lua","w");
    io.write(my_file, "local function numL01();\n   return "..inSwitch..";\nend;");
    io.close(my_file);
    my_file = nil;
end;




--######## function for testing the next script ###############

local function findLogSwitchOne_func()

--#### missing free logical switch or costum function
   if (step == 11) then --#### missing free logical switch or free customFunctions
       return nil, nil, step;
     end;

--#### found block
   if (step == 9) then --#### found - Logical switch L01
         return searchedSwitchIndex, nil, step;
     end;
   if (step == 8) then --#### found - clean up logical switch and customfunctions
        model.setCustomFunction(specFuncIdOne, { switch=0, func=0, value=0, mode= 0, param=0, active=0});
        model.setCustomFunction(specFuncIdTwo, { switch=0, func=0, value=0, mode= 0, param=0, active=0});
        model.setLogicalSwitch(logSwitchId, { func=0, v1=0 , v2=0, ["and"]= 0, delay=0, duration=0});
        findLogSwitchOne_file(searchedSwitchIndex);
       step = 9;
       return searchedSwitchIndex, nil, step;
     end;
   if (step == 7) then --#### found - set back original Gvar9 value
        model.setCustomFunction(specFuncIdOne, {switch= loopNr, func=5, value=existingGvar9Value, mode= 0, param=8, active=1});
        model.setCustomFunction(specFuncIdTwo, {switch=-loopNr, func=5, value=existingGvar9Value, mode= 0, param=8, active=1})
       step = 8;
     end;

--#### not found block
   if (step == 6) then --#### not found - Logical switch L01
         return nil, nil, step;
       end;
   if (step == 5) then --#### not found - clean up logical switch and customfunctions
        model.setCustomFunction(specFuncIdOne, { switch=0, func=0, value=0, mode= 0, param=0, active=0});
        model.setCustomFunction(specFuncIdTwo, { switch=0, func=0, value=0, mode= 0, param=0, active=0});
        model.setLogicalSwitch(logSwitchId, { func=0, v1=0 , v2=0, ["and"]= 0, delay=0, duration=0});
       step = 6;
     end;
   if (step == 4) then --#### not found; set back original Gvar9 value
        model.setCustomFunction(specFuncIdOne, {switch= loopNr, func=5, value=existingGvar9Value, mode= 0, param=8, active=1});
        model.setCustomFunction(specFuncIdTwo, {switch=-loopNr, func=5, value=existingGvar9Value, mode= 0, param=8, active=1})
       step = 5;
     end;

--#### test block
   if (step == 3) then
       valueTwo = getValue("gvar9");
       if valueTwo ~= valueOne then
          searchedSwitchIndex = loopNr - logSwitchId ;
          step = 7;
        else
          if (loopNr > loopNrMin) then 
              loopNr = loopNr - 1;
              step = 1;
            else
              step = 4;
            end
        end;
     end;
   if (step == 2) then
        valueOne = getValue("gvar9");
        model.setLogicalSwitch(logSwitchId, {func=1, v1=0 , v2=0, ["and"]= 1, delay=0, duration=0});
       step = 3;
     end;
   if (step == 1) then
        model.setLogicalSwitch(logSwitchId, {func=1, v1=0, v2=0, ["and"]= -1, delay=0, duration=0});
        model.setCustomFunction(specFuncIdOne, {switch=loopNr, func=5, value=-100, mode= 0, param=8, active=1});
        model.setCustomFunction(specFuncIdTwo, {switch=-loopNr, func=5, value=100, mode= 0, param=8, active=1});
       step = 2;
     end;

--#### start block
   if (step == 0) then
       existingGvar9Value = getValue("gvar9");
       findLogSwitchOne_start()
     end;

    return nil, (loopNr - logSwitchId), step;

end;



--##########  run function ##############
local function run()

     lcd.clear()
     lcd.drawText (0,  0, "searching IndexNr", MIDSIZE);
     lcd.drawText (0, 15, "of Log Switch L01", MIDSIZE);

     if (stepStatus == nil) or (stepStatus < 11) then foundSwitch, testedSwitch, stepStatus = findLogSwitchOne_func(); end;
     if (stepStatus ~= nil) then
        if (stepStatus > 0) and (stepStatus < 4)  then lcd.drawText (0, 40, "testing: "..testedSwitch, SMLSIZE); end;
        if (stepStatus == 6) then lcd.drawText (0, 40, "Index of L01 not found", SMLSIZE); end;
        if (stepStatus == 9) then lcd.drawText (0, 40, "Index of L01: "..foundSwitch, SMLSIZE); end;
        if (stepStatus == 11) then 
            lcd.drawText(0, 35, "there needs to be available:",SMLSIZE);
            lcd.drawText(0, 45, "one Logical Switch and",SMLSIZE);
            lcd.drawText(0, 55, "two Custom Functions",SMLSIZE);
          end;
       end;

return 0;
end

return {run=run}